/**
 * PETALS - PETALS Services Platform. Copyright (c) 2006 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.se.xslt.service;

import java.io.ByteArrayOutputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.URIResolver;
import javax.xml.transform.stream.StreamResult;

import org.ow2.petals.se.xslt.ServiceUnitURIResolver;

/**
 * @author alouis, ofabre, cgirodengo
 * 
 */
public class XsltService {

    /**
     * Creates a new instance of {@link XsltService}
     * 
     */
    public XsltService() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.se.xslt.Xslt#transform(javax.xml.transform.Source,
     * javax.xml.transform.Templates)
     */
    public ByteArrayOutputStream transform(Source xml, Templates xslTemplates, String installRoot)
            throws TransformerException {
        Transformer transformer = xslTemplates.newTransformer();
        // TODO : the URIResolver objects must be cached as well as the
        // xslTemplates
        URIResolver uriResolver = new ServiceUnitURIResolver(installRoot);
        transformer.setURIResolver(uriResolver);
        ByteArrayOutputStream outputStream = transformSource(xml, transformer);
        return outputStream;
    }

    /**
     * Transform the source into a {@code ByteArrayOutputStream}.
     * 
     * @param xml
     * @param transformer
     * @return
     * @throws TransformerException
     */
    private static final ByteArrayOutputStream transformSource(Source xml, Transformer transformer)
            throws TransformerException {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        Result streamResult = new StreamResult(outputStream);
        transformer.transform(xml, streamResult);
        return outputStream;
    }

}
